package com.company;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.security.PrivateKey;
import java.util.ArrayList;

/**
 * a class that extends thread we use it to hndle multiple clients
 */
public class ClientHandler extends Thread{

    private BufferedReader reader;
    private PrintWriter writer;
    private Socket s;
    private ArrayList<String> messages;

    public ClientHandler(Socket s){
        try {
            this.s = s;
            messages = new ArrayList<>();
            reader = new BufferedReader(new InputStreamReader(s.getInputStream()));
            writer = new PrintWriter(s.getOutputStream(),true);
        }catch (IOException e){
            e.printStackTrace();
        }
    }

    @Override
    public void run(){
        try {
            while (true){
                String message = reader.readLine();
                if(message.toUpperCase().equals("OVER")){
                    for (String m : messages){
                        writer.println(m);
                    }
                    writer.println("finished");
                    reader.close();
                    writer.close();
                    s.close();
                    break;
                }
                messages.add(message);
                writer.println("[Server] received your message : "+message);
            }
        }catch (IOException e) {
            e.printStackTrace();
        }
    }
}
